-- Lesson: Observe TerraME models growing.
-- Author: Tiago Carneiro

--------------------------------------------------------------
-- PARAMETER
--------------------------------------------------------------

GROWTH_RATE = 0.3

--------------------------------------------------------------
-- MODEL
--------------------------------------------------------------

function change( stockPast )
	return GROWTH_RATE * stockPast
end 

ag = Agent{
	stock  		= 10,
	execute		= function( self )
		self.stock = self.stock + change( self.stock );
	end
}

--------------------------------------------------------------
-- SIMULATION
--------------------------------------------------------------

obs = Observer{subject = ag, type = "chart", attributes = {"stock"} }

for t = 1, 100 do

	ag:execute();
	print( ag.stock )
	
	ag:notify(t)
	
end