-- Lesson: Homeostasy - System are never closed. 
--         They search for equilibrium (steady state) through 
--         negative feedback.
-- Author: Tiago Carneiro

------------------------------------------------------------
-- PARAMETER
------------------------------------------------------------
FIXED_GROWTH = 2
DECAY_RATE = 0.1 -- SECOND try: 0.1	 (0.4)	0.7

------------------------------------------------------------
-- MODEL
------------------------------------------------------------
function change( stockPast )
	return FIXED_GROWTH  - DECAY_RATE * stockPast
end 


ag = Agent{
	stock  		= 10, -- FIRST try: 	 0.0 		2.0 		4.0		(10.0)	 	100.0
	execute		= function( self )
		self.stock = self.stock + change( self.stock );
	end
}


------------------------------------------------------------
-- SIMULATION
------------------------------------------------------------
obs = Observer{subject = ag, type = "chart", attributes = {"stock"} }

for t = 1, 100 do

	ag:execute();
	print( ag.stock )
	
	ag:notify(t)
	
end