-- Lesson: Discrete changes - Caos or error propagation? Discrete or continuous systems? Instantaneous or delayed feedbacks?
--
-- PARAMETER
--

GROWTH_RATE =  2.5 -- try  0   0.05  0.1  0.3  0.7 	2.0 	2.5		3.0		4.0
SUPPORT_CAPACITY = 100

--
-- MODEL
--

function change( stockPast )
	return GROWTH_RATE * stockPast * ( 1 - stockPast/SUPPORT_CAPACITY )
end 

ag = Agent{
	stock  		= 10,
	execute		= function( self )
		self.stock = self.stock + change( self.stock );
	end
}

--
-- SIMULATION
--

obs = Observer{subject = ag, type = "chart", attributes = {"stock"} }

for t = 1, 100 do

	ag:execute();
	print( ag.stock )
	
	ag:notify(t)
	
end